--NazUpg: Pevodky
--PopisUpg: Reakce na zmnu obdob
--KontrolaUpg: 
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
ALTER TRIGGER dbo.trPdDokInsUpd ON dbo.PdDok
FOR INSERT,UPDATE
AS
BEGIN
set nocount on
------------------------------------------------------------------
-- jak akce
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
------------------------------------------------------------------
declare @Hlaska varchar(4000) select @Hlaska=''
declare @IdDrdok char(2) select @IdDrdok=max(IdDrdok) from inserted
---------------------------- patn den dokladu vzhledem k obdob --------------------------
-- spolen pro insert i update
select @Hlaska='Chyba etnho obdob '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+char(13)
 from inserted i join dbo.ExObdUc o on i.IdDrdok=o.IdDrdok and i.Obd=o.Obd and i.Rok=o.Rok
 where
  --(JeZmenaObdUc=0 and
   (i.DenDok<o.DenOd or
    i.DenDok>o.DenDo
   )
  --)
  or  (@Akce='I' and not o.PovolUc>'0')
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
----------------------------------- kontrola smlouvy -------------------------------------------
-- jen pro insert, pro update je ne
if @Akce='I'
begin
 select @Hlaska='Smlouva '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+' nepat adrestovi, pjemci ani nen veobecn (adrest=0), nebo neodpovd typ komise nebo datum dokladu.'
  from inserted i
   left join dbo.AdSmlProd s on s.SmlAdr=i.SmlAdr and s.Komise=i.Komise and (s.IdAdr=i.IdAdr or s.IdAdr=i.IdAdrPri or s.IdAdr='0') and not s.DenOd>i.DenDok and not s.DenDo<i.DenDok
  where s.SmlAdr is null
 if  @Hlaska>''
 begin
  raiserror (@Hlaska,11,2)
  rollback transaction
  return
 end
end
-------------------------- doplnn text (insert a radji i update) --------------------------
insert dbo.PdTxt (CisDok,   Uvod  ,   Zaver ,  IdTxt1,  IdTxt2,  IdTxt3,  IdTxt4,  IdTxt5) 
 select         i.CisDok,tu.TxtTxt,tz.TxtTxt,r.IdTxt1,r.IdTxt2,r.IdTxt3,r.IdTxt4,r.IdTxt5
  from inserted i
   join PdRada r on r.IdRada=i.IdRada
   join ExTxt tu on tu.IdTxt=r.IdTxtUvod
   join ExTxt tz on tz.IdTxt=r.IdTxtZaver
   left join dbo.PdTxt t on t.CisDok=i.CisDok
  where t.CisDok is null
------------------------------------------------------------------------------------------------
-- te u kon insert a hraje se jen s update
if @Akce='I'
 return
------------------------- nelze zmnit slo a druh dokladu --------------------------------
select @Hlaska='Nelze mnit slo nebo druh dokladu '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))
 from inserted i
  left join deleted d on d.CisDok=i.CisDok and d.IdDrdok=i.IdDrdok
 where d.CisDok is null
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
--------------------- zmna smlouvy ------------------------
-- pi update se kontroluje smlouva jen v ppad, e zmnili parametry pro vbr smlouvy
select @Hlaska='Smlouva '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+'nepat adrestovi, pjemci ani nen veobecn (adrest=0), nebo neodpovd typ komise nebo datum dokladu.'
 from inserted i
  join deleted d on d.CisDok=i.CisDok and not (i.SmlAdr=d.SmlAdr and i.IdAdr=d.IdAdr and i.IdAdrPri=d.IdAdrPri and i.Komise=d.Komise and i.DenDok=d.DenDok)
  left join dbo.AdSmlProd s on s.SmlAdr=i.SmlAdr and s.Komise=i.Komise and (s.IdAdr=i.IdAdr or s.IdAdr=i.IdAdrPri or s.IdAdr='0') and not s.DenOd>i.DenDok and not s.DenDo<i.DenDok
 where s.SmlAdr is null
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
--------------------- zmna obdob, z nich aspo jedno je zakzan ------------------------
select @Hlaska='Zmna neplatnho etnho obdob '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))+char(13)
 from inserted i
  join deleted d on i.CisDok=d.CisDok
  join dbo.ExObdUc  oi on i.IdDrdok=oi.IdDrdok and i.Obd=oi.Obd and i.Rok=oi.Rok
  join dbo.ExObdUc  od on d.IdDrdok=od.IdDrdok and d.Obd=od.Obd and d.Rok=od.Rok
 where not (i.Obd=d.Obd and i.Rok=d.Rok) and not (oi.PovolUc>'0' and od.PovolUc>'0')
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
-------------------- uzaven doklady - podpis, blokovn, obdob - kontrola jen zkladnch parametr -------------------------
select @Hlaska='Zmna dokladu v uzavenm obdob nebo podepsanho i zablokovanho dokladu '+@IdDrdok+' '+convert(varchar(15),min(i.CisDok))
 from
  (
   select i.CisDok,i.IdDrdok from inserted i join dbo.ExPodpisUc  p on i.IdDrdok=p.IdDrdok and i.CisDok=p.CisDok union
   select i.CisDok,i.IdDrdok from inserted i join dbo.ExPodpisDok p on i.IdDrdok=p.IdDrdok and i.CisDok=p.CisDok union
   select i.CisDok,i.IdDrdok from inserted i join deleted         d on i.IdDrdok=d.IdDrdok and i.CisDok=d.CisDok where i.Blok>'0' and d.Blok>'0' union
   select i.CisDok,i.IdDrdok from inserted i join dbo.ExObdUc     o on i.IdDrdok=o.IdDrdok and i.Obd=o.Obd and i.Rok=o.Rok where not o.PovolUc>'0' union
   select d.CisDok,d.IdDrdok from deleted  d join dbo.ExObdUc     o on d.IdDrdok=o.IdDrdok and d.Obd=o.Obd and d.Rok=o.Rok where not o.PovolUc>'0'
  ) x
  join inserted i on i.CisDok=x.CisDok
  join deleted d on d.CisDok=x.CisDok
 where not
  (i.DenDok=d.DenDok and i.IdAdr=d.IdAdr and i.IdAdrPri=d.IdAdrPri and i.CenaCelkKc=d.CenaCelkKc and i.CenaCelkMena=d.CenaCelkMena and i.IdMena=d.IdMena and i.Kurs=d.Kurs
   and i.IdStr=d.IdStr and i.IdZak=d.IdZak and i.IdCin=d.IdCin and i.IdSbo=d.IdSbo and i.IdAut=d.IdAut and i.Obd=d.Obd and i.Rok=d.Rok and i.Komise=d.Komise and i.SmlAdr=d.SmlAdr
  )
if  @Hlaska>''
begin
 raiserror (@Hlaska,11,2)
 rollback transaction
 return
end
-----------------------------------------------------------------------------------------------------------------
declare
@StaraSlevaProc numeric(19,6),
@NovaSlevaProc numeric(19,6),
@ZaokRadCenaKc smallInt,
@ZaokRadCenaMena smallInt,
@DphFakNevracetDleCeniku char(1)
select @ZaokRadCenaKc          =dbo.fnChar2Int(dbo.fnExNastav('ZaokRadCenaKc',4,default))
select @ZaokRadCenaMena        =dbo.fnChar2Int(dbo.fnExNastav('ZaokRadCenaKc',4,@ZaokRadCenaKc))
select @DphFakNevracetDleCeniku=dbo.fnChar2Bit(dbo.fnExNastav('DphFakNevracetDleCeniku','0',default))
------------------ pepoet cen pi zmn slev - ignoruje ppady, kdy byla pvodn sleva 100% -------------
if exists(select i.CisDok from inserted i join deleted d on i.CisDok=d.CisDok where i.SlevaProc+i.SlevaHotProc<>d.SlevaProc+d.SlevaHotProc and d.SlevaProc+d.SlevaHotProc<>100)
begin
 Update r set
   @NovaSlevaProc =i.SlevaProc+i.SlevaHotProc,
   @StaraSlevaProc=d.SlevaProc+d.SlevaHotProc,
   CenaCelkKc     =                                 round( (r.CenaCelkKc/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)           , @ZaokRadCenaKc),
   CenaMjKc       =case when MnozCelk=0 then 0 else round(((r.CenaCelkKc/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100))/MnozCelk , @ZaokRadCenaKc) end,
   CenaVahaKc     =case when VahaCelk=0 then 0 else round(((r.CenaCelkKc/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100))/VahaCelk , @ZaokRadCenaKc) end
  from dbo.PdRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
  where (rtrim(i.IdMena)<='0' or i.Kurs=0) and i.SlevaProc+i.SlevaHotProc<>d.SlevaProc+d.SlevaHotProc and d.SlevaProc+d.SlevaHotProc<>100
 Update r set
   @NovaSlevaProc =i.SlevaProc+i.SlevaHotProc,
   @StaraSlevaProc=d.SlevaProc+d.SlevaHotProc,
   CenaCelkMena   =                                 round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)                 ,@ZaokRadCenaMena),
   CenaMjMena     =case when MnozCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)/MnozCelk        ,@ZaokRadCenaMena) end,
   CenaVahaMena   =case when VahaCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)/VahaCelk        ,@ZaokRadCenaMena) end,
   CenaCelkKc     =                                 round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)*i.Kurs          ,@ZaokRadCenaKc),
   CenaMjKc       =case when MnozCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)*i.Kurs/MnozCelk ,@ZaokRadCenaKc)end,
   CenaVahaKc     =case when VahaCelk=0 then 0 else round((r.CenaCelkMena/(1-@StaraSlevaProc/100.0))*(1-@NovaSlevaProc/100)*i.Kurs/VahaCelk ,@ZaokRadCenaKc)end
  from dbo.PdRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
  where rtrim(i.IdMena)>'0' and i.Kurs<>0 and i.SlevaProc+i.SlevaHotProc<>d.SlevaProc+d.SlevaHotProc and d.SlevaProc+d.SlevaHotProc<>100
end
----------------------------------------------- zmna skupiny DPH ----------------------------------------------
-------------------------------------- zmna kursu -------------------------------------------------
if @Akce='U'
begin
 if exists(select i.CisDok from inserted i join deleted d on i.CisDok=d.CisDok where not i.Kurs=d.Kurs and not i.Kurs=0)
 begin
  update r set
    CenaCelkMena   =case when     r.CenaCelkMena=0 then                             round(r.CenaCelkKc  /i.Kurs,@ZaokRadCenaMena)                                                                   else r.CenaCelkMena end,
    CenaMjMena     =case when     r.CenaMjMena  =0 then case when r.MnozCelk=0 then round(r.CenaMjKc    /i.Kurs,@ZaokRadCenaMena) else round(r.CenaCelkKc  /r.MnozCelk/i.Kurs,@ZaokRadCenaMena) end else r.CenaMjMena   end,
    CenaVahaMena   =case when     r.CenaVahaMena=0 then case when r.VahaCelk=0 then round(r.CenaVahaKc  /i.Kurs,@ZaokRadCenaMena) else round(r.CenaCelkKc  /r.VahaCelk/i.Kurs,@ZaokRadCenaMena) end else r.CenaVahaMena end,
    CenaCelkKc     =case when not r.CenaCelkMena=0 then                             round(r.CenaCelkMena*i.Kurs,@ZaokRadCenaKc  )                                                                   else r.CenaCelkKc   end,
    CenaMjKc       =case when not r.CenaMjMena  =0 then case when r.MnozCelk=0 then round(r.CenaMjMena  *i.Kurs,@ZaokRadCenaKc  ) else round(r.CenaCelkMena/r.MnozCelk*i.Kurs,@ZaokRadCenaKc  ) end else r.CenaMjKc     end,
    CenaVahaKc     =case when not r.CenaVahaMena=0 then case when r.VahaCelk=0 then round(r.CenaVahaMena*i.Kurs,@ZaokRadCenaKc  ) else round(r.CenaCelkMena/r.VahaCelk*i.Kurs,@ZaokRadCenaKc  ) end else r.CenaVahaKc   end
   from dbo.PdRad r join inserted i on i.CisDok=r.CisDok join deleted d on d.CisDok=i.CisDok
   where not i.Kurs=d.Kurs and not i.Kurs=0 and not r.CenaCelkMena=0
 end
end
--------------------------------------- oprava pehledu pohyb -----------------------------------------------
if exists(select i.CisDok from inserted i join deleted d on i.CisDok=d.CisDok where not (i.DenDok=d.DenDok and i.Mes=d.Mes and i.IdAdr=d.IdAdr))
begin
 update p set DenDok=convert(datetime,convert(varchar,i.DenDok,101),101), HodDok=convert(tinyint,left(convert(varchar,i.DenDok,114),2)), Mes=i.Mes, Obd=i.Obd, Rok=i.Rok, IdAdr=i.IdAdr
  from dbo.SkPohyb p join inserted i on p.CisDok=i.CisDok and p.IdDrdok=i.IdDrdok join deleted d on i.CisDok=d.CisDok
  where not (i.DenDok=d.DenDok and i.Mes=d.Mes and i.IdAdr=d.IdAdr)
end
END
GO