--NazUpg: Dodavatelsk zlohy
--PopisUpg: Zapsan sla dokladu pi importu a exportu
--KontrolaUpg: 
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
ALTER TRIGGER dbo.tiDzRadInsUpd ON dbo.DzRad
INSTEAD OF INSERT,UPDATE
AS
BEGIN
set nocount on
-----------------------------------------------------------------------------------------------
-- jak akce 
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-----------------------------------------------------------------------------------------------
declare
 @RadDok smallInt,
 @PorTisk money,
 @CenaPrumCelkKc money,
 @Hlaska varchar(4000)
-----------------------------------------------------------------------------------------------
if @Akce='U'
begin
 ------------------- neumonm zmnu sla dku dokladu
 if exists (select i.CisDok from inserted i left join deleted d on d.CisDok=i.CisDok and d.RadDok=i.RadDok where d.RadDok is null)
 begin
  select @Hlaska='Nelze mnit slo dku dokladu'
  select @Hlaska=@Hlaska+' '+convert(varchar(15),i.CisDok)
                            from inserted i left join deleted d on d.CisDok=i.CisDok and d.RadDok=i.RadDok where d.RadDok is null
  raiserror (@Hlaska,11,2)
  return
 end
end
--------------------------------- doasn tabulka pro pravu vstupnch dat -------------------------------
declare @ins table (
  IdId           int identity(1,1) NOT NULL primary key
 ,IdDzRad        int NULL
 ,CisDok         numeric(15,0) NULL
 ,RadDok         smallint NULL
 ,PorTisk        numeric(19,4) NULL
 ,IdZbozi        char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdDph          char(10) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdStr          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdZak          char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdCin          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdSbo          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdAut          char(10) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,MnozCelk       numeric(19,6) NULL
 ,VahaCelk       numeric(19,6) NULL
 ,BalCelk        numeric(19,6) NULL
 ,CenaPuvKc      money NULL
 ,CenaPuvMena    money NULL
 ,CenaMjKc       money NULL
 ,CenaMjMena     money NULL
 ,CenaVahaKc     money NULL
 ,CenaVahaMena   money NULL
 ,CenaCelkKc     money NULL
 ,CenaCelkMena   money NULL
 ,CenaPrumCelkKc money NULL
 ,BonProc        numeric(19,6) NULL
 ,ZboziUpr       varchar(100) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,NazRad         varchar(250) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,Pocitat        smallint NULL
 ,Misto          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,CenyDleVahy    char(1) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,Blok           char(1) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,Stav           char(1) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,ZarKdo         char(20) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,ZarKdy         datetime NULL
 ,OprKdo         char(20) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,OprKdy         datetime NULL
 ,Otisk          varbinary(8) NULL
 ,Serie          char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdRadVazba     int NULL
 ,CisDokVazba    numeric(15,0) NULL
 ,IdRadOdkud     int NULL
 ,CisDokOdkud    numeric(15,0) NULL
 ,IdRadKam       int NULL
 ,CisDokKam      numeric(15,0) NULL
)
insert @ins(IdDzRad,  CisDok,  RadDok,  PorTisk,  IdZbozi,  IdDph,  IdStr,  IdZak,  IdCin,  IdSbo,  IdAut,  MnozCelk,  VahaCelk,  BalCelk,  CenaPuvKc,  CenaPuvMena,  CenaMjKc,  CenaMjMena,  CenaVahaKc,  CenaVahaMena,  CenaCelkKc,  CenaCelkMena,  CenaPrumCelkKc,  BonProc,  ZboziUpr,        NazRad ,  Pocitat,  Misto,  CenyDleVahy,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy,  Otisk,  Serie,  IdRadVazba,  CisDokVazba,  IdRadOdkud,  CisDokOdkud,  IdRadKam,  CisDokKam)
 select   i.IdDzRad,i.CisDok,i.RadDok,i.PorTisk,i.IdZbozi,i.IdDph,i.IdStr,i.IdZak,i.IdCin,i.IdSbo,i.IdAut,i.MnozCelk,i.VahaCelk,i.BalCelk,i.CenaPuvKc,i.CenaPuvMena,i.CenaMjKc,i.CenaMjMena,i.CenaVahaKc,i.CenaVahaMena,i.CenaCelkKc,i.CenaCelkMena,i.CenaPrumCelkKc,i.BonProc,i.ZboziUpr,rtrim(i.NazRad),i.Pocitat,i.Misto,i.CenyDleVahy,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy,i.Otisk,i.Serie,i.IdRadVazba,i.CisDokVazba,i.IdRadOdkud,i.CisDokOdkud,i.IdRadKam,i.CisDokKam
  from inserted i
-- doplnn sla dku nebo poad tisku
if @Akce='I'
begin
 if exists(select RadDok from @ins where RadDok*PorTisk=0)
 begin
  update i set
   @RadDok=case
    when RadDok>0 then RadDok
    when PorTisk>0 and PorTisk<32000 then convert(smallint,PorTisk)
    else (select isNull(max(r.RadDok),0) + 1 from dbo.DzRad r where r.CisDok=i.CisDok)
        +(select count(*) from @ins pred where pred.IdId<i.IdId)
    end,
   @PorTisk=case when PorTisk<>0 then PorTisk else @RadDok end,
   RadDok=@RadDok,
   PorTisk=@PorTisk
  from @ins i
  where RadDok*PorTisk=0
 end
end
-- doplnn IdDph
if exists(select RadDok from @ins where not IdDph>'0')
begin
 update i set IdDph=c.IdDph
 from @ins i join dbo.CeZbozi c on c.IdZbozi=i.IdZbozi
 where not i.IdDph>'0'
end
-- prava DPH dku podle hlaviky
update r set r.IdDph=h.IdDph
 from @ins r
  join dbo.DzDok h on h.CisDok=r.CisDok
  join dbo.DpDph sh on sh.IdDph=h.IdDph
  join dbo.DpDph sr on sr.IdDph=r.IdDph
 where h.IdDph>'0' and not sh.IdTypDph>'0' and not sr.IdTypDph>'0'
-- prava prmrn ceny - vdy insert, upgrade jen pi zmn poloky nebo mnostv
if exists
 (select i.RadDok 
   from @ins i
         join DzDok         h on h.CisDok=i.CisDok
    left join deleted       d on i.CisDok=d.CisDok and i.RadDok=d.RadDok 
         join dbo.CeZbozi   z on i.IdZbozi=z.IdZbozi 
         join dbo.CeStav    s on i.IdZbozi=s.IdZbozi and h.Komise =s.Komise
    left join dbo.CeCenaNak n on n.IdZbozi=s.IdZbozi and n.IdMena='0'
   where not
    (
     @Akce='U' and 
     i.IdZbozi=isnull(d.IdZbozi,'0') and
     i.MnozCelk=isnull(d.MnozCelk,0) and
     i.VahaCelk=isnull(d.VahaCelk,0) and
     h.Komise=isnull(h.Komise,'0')
    )
 )
begin
 update i set 
  @CenaPrumCelkKc=
      case
      when z.CenyDleVahy>'0' then
       case
       when s.VahaCelk=0 then convert(money,round(case when s.CenaPrumVahaKc>0 then s.CenaPrumVahaKc else isnull(n.CenaA,0) end*i.VahaCelk,2)) 
       else                   convert(money,round(s.CenaPrumCelkKc*(i.VahaCelk/s.VahaCelk),2))
       end
      else
       case 
       when s.MnozCelk=0 then convert(money,round(case when s.CenaPrumMjKc  >0 then s.CenaPrumMjKc   else isnull(n.CenaA,0) end*i.MnozCelk,2)) 
       else                   convert(money,round(s.CenaPrumCelkKc*(i.MnozCelk/s.MnozCelk),2)) 
       end
      end
  ,CenaPrumCelkKc=@CenaPrumCelkKc
 from @ins i
       join DzDok         h on h.CisDok=i.CisDok
  left join deleted       d on i.CisDok=d.CisDok and i.RadDok=d.RadDok 
       join dbo.CeZbozi   z on i.IdZbozi=z.IdZbozi 
       join dbo.CeStav    s on i.IdZbozi=s.IdZbozi and h.Komise =s.Komise
  left join dbo.CeCenaNak n on n.IdZbozi=s.IdZbozi and n.IdMena='0'
 where not
    (
     @Akce='U' and 
     i.IdZbozi=isnull(d.IdZbozi,'0') and
     i.MnozCelk=isnull(d.MnozCelk,0) and
     i.VahaCelk=isnull(d.VahaCelk,0) and
     h.Komise=isnull(h.Komise,'0')
    )
end
------------------------------------------------------------------------------
-- vlastn insert
if @Akce='I'
begin
 insert dbo.DzRad(CisDok,  RadDok,  IdZbozi,  PorTisk,  IdDph,  IdStr,  IdZak,  IdCin,  IdSbo,  IdAut,  MnozCelk,  VahaCelk,  BalCelk,  CenaPuvKc,  CenaPuvMena,  CenaMjKc,  CenaMjMena,  CenaVahaKc,  CenaVahaMena,  CenaCelkKc,  CenaCelkMena,  CenaPrumCelkKc,  BonProc,  ZboziUpr,  NazRad,  Pocitat,  Misto,  CenyDleVahy,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy,  Serie,  IdRadVazba,  CisDokVazba,  IdRadOdkud,  CisDokOdkud,  IdRadKam,  CisDokKam)
  select        i.CisDok,i.RadDok,i.IdZbozi,i.PorTisk,i.IdDph,i.IdStr,i.IdZak,i.IdCin,i.IdSbo,i.IdAut,i.MnozCelk,i.VahaCelk,i.BalCelk,i.CenaPuvKc,i.CenaPuvMena,i.CenaMjKc,i.CenaMjMena,i.CenaVahaKc,i.CenaVahaMena,i.CenaCelkKc,i.CenaCelkMena,i.CenaPrumCelkKc,i.BonProc,i.ZboziUpr,i.NazRad,i.Pocitat,i.Misto,i.CenyDleVahy,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy,i.Serie,i.IdRadVazba,i.CisDokVazba,i.IdRadOdkud,i.CisDokOdkud,i.IdRadKam,i.CisDokKam
   from @ins i
 return
end
-- vlastn update
update r set --nezapisuje se CisDok,RadDok,ZarKdo,OprKdo
  PorTisk        =i.PorTisk,
  IdZbozi        =i.IdZbozi,
  IdDph          =i.IdDph,
  IdStr          =i.IdStr,
  IdZak          =i.IdZak,
  IdCin          =i.IdCin,
  IdSbo          =i.IdSbo,
  IdAut          =i.IdAut,
  MnozCelk       =i.MnozCelk,
  VahaCelk       =i.VahaCelk,
  BalCelk        =i.BalCelk,
  CenaPuvKc      =i.CenaPuvKc,
  CenaPuvMena    =i.CenaPuvMena,
  CenaMjKc       =i.CenaMjKc,
  CenaMjMena     =i.CenaMjMena,
  CenaVahaKc     =i.CenaVahaKc,
  CenaVahaMena   =i.CenaVahaMena,
  CenaCelkKc     =i.CenaCelkKc,
  CenaCelkMena   =i.CenaCelkMena,
  CenaPrumCelkKc =i.CenaPrumCelkKc,
  BonProc        =i.BonProc,
  ZboziUpr       =i.ZboziUpr,
  NazRad         =i.NazRad,
  Pocitat        =i.Pocitat,
  Misto          =i.Misto,
  CenyDleVahy    =i.CenyDleVahy,
  Blok           =i.Blok,
  Stav           =i.Stav,
  OprKdo         =i.OprKdo,
  OprKdy         =i.OprKdy,
  Serie          =i.Serie,
  IdRadVazba     =case when i.IdRadVazba=0  then null else i.IdRadVazba  end,
  CisDokVazba    =case when i.CisDokVazba=0 then null else i.CisDokVazba end,
  IdRadOdkud     =case when i.IdRadOdkud=0  then null else i.IdRadOdkud  end,
  CisDokOdkud    =case when i.CisDokOdkud=0 then null else i.CisDokOdkud end,
  IdRadKam       =case when i.IdRadKam=0    then null else i.IdRadKam    end,
  CisDokKam      =case when i.CisDokKam=0   then null else i.CisDokKam   end
 from @ins i
  join dbo.DzRad r on r.IdDzRad=i.IdDzRad
END
GO