--NazUpg: Dodavatelsk nabdky
--PopisUpg: Sjednocen pol dk doklad
--KontrolaUpg: 
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='DnRad' and c.name='CenaPrumCelkKc')
 alter table DnRad add CenaPrumCelkKc money not null constraint DF_DnRad_CenaPrumCelkKc default 0
GO
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='DNRad' and c.name='DenPuv')
 alter table DNRad add DenPuv datetime
GO
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='DnRad' and c.name='IdIso')
 alter table DnRad add IdIso char(10) COLLATE SQL_Czech_CP1250_CI_AS not null constraint DF_DnRad_IdIso default '0' constraint FK_DnRad_IdIso foreign key(IdIso) references ExIso(IdIso)
GO
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='DnRad' and c.name='PaletCelk')
 alter table DnRad add PaletCelk numeric(19,6) not null constraint DF_DnRad_PaletCelk default 0
GO
if not exists(select * from sysobjects o join syscolumns c on c.id=o.Id where o.name='DnRad' and c.name='IdRoKrok')
 alter table DnRad add IdRoKrok int
GO
DBCC INDEXDEFRAG(0,'DnRad')
GO
ALTER TRIGGER dbo.tiDnRadInsUpd ON dbo.DnRad
INSTEAD OF INSERT,UPDATE
AS
BEGIN
set nocount on
-----------------------------------------------------------------------------------------------
-- jak akce 
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-----------------------------------------------------------------------------------------------
declare
 @RadDok smallInt,
 @PorTisk money,
 @CenaPrumCelkKc money,
 @Hlaska varchar(4000)
-----------------------------------------------------------------------------------------------
if @Akce='U'
begin
 ------------------- neumonm zmnu sla dku dokladu
 if exists (select i.CisDok from inserted i left join deleted d on d.CisDok=i.CisDok and d.RadDok=i.RadDok where d.RadDok is null)
 begin
  select @Hlaska='Nelze mnit slo dku dokladu'
  select @Hlaska=@Hlaska+' '+convert(varchar(15),i.CisDok)
                            from inserted i left join deleted d on d.CisDok=i.CisDok and d.RadDok=i.RadDok where d.RadDok is null
  raiserror (@Hlaska,11,2)
  return
 end
end
--------------------------------- doasn tabulka pro pravu vstupnch dat -------------------------------
declare @ins table (
  idid           int identity(1,1) NOT NULL primary key
 ,IdDnRad        int NULL
 ,CisDok         numeric(15,0) NULL
 ,RadDok         smallint NULL
 ,PorTisk        numeric(19,4) NULL
 ,IdZbozi        char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdDph          char(10) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdStr          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdZak          char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdCin          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdSbo          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdAut          char(10) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,MnozCelk       numeric(19,6) NULL
 ,VahaCelk       numeric(19,6) NULL
 ,BalCelk        numeric(19,6) NULL
 ,PaletCelk      numeric(19,6) NULL
 ,CenaPuvKc      money NULL
 ,CenaPuvMena    money NULL
 ,CenaMjKc       money NULL
 ,CenaMjMena     money NULL
 ,CenaVahaKc     money NULL
 ,CenaVahaMena   money NULL
 ,CenaCelkKc     money NULL
 ,CenaCelkMena   money NULL
 ,CenaPrumCelkKc money NULL
 ,BonProc        numeric(19,6) NULL
 ,ZboziUpr       varchar(100) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,NazRad         varchar(250) COLLATE SQL_Czech_CP1250_CI_AS NULL 
 ,Pocitat        smallint NULL
 ,Misto          char(15) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,ObjKodZbozi    char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,MnozDod        numeric(19,6) NULL
 ,MnozKorekce    numeric(19,6) NULL
 ,MnozZbyva      numeric(19,6) NULL
 ,VahaDod        numeric(19,6) NULL
 ,VahaKorekce    numeric(19,6) NULL
 ,VahaZbyva      numeric(19,6) NULL
 ,DenDod         smalldatetime NULL
 ,DenKon         smalldatetime NULL
 ,DenPotvrz      smalldatetime NULL
 ,DenPuv         smalldatetime NULL
 ,DenRez         smalldatetime NULL
 ,Rez            varchar(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,CenyDleVahy    char(1) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,Blok           char(1) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,Stav           char(1) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,ZarKdo         char(20) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,ZarKdy         datetime NULL
 ,OprKdo         char(20) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,OprKdy         datetime NULL
 ,Otisk          varbinary(8) NULL
 ,Serie          char(25) COLLATE SQL_Czech_CP1250_CI_AS NULL
 ,IdRadVazba     int NULL
 ,CisDokVazba    numeric(15,0) NULL
 ,IdRadOdkud     int NULL
 ,CisDokOdkud    numeric(15,0) NULL
 ,IdRadKam       int NULL
 ,CisDokKam      numeric(15,0) NULL
 ,IdRoKrok       int NULL
 ,IdIso          char(10) COLLATE SQL_Czech_CP1250_CI_AS NULL
)
insert @ins(IdDnRad,  CisDok,  RadDok,  PorTisk,  IdZbozi,  IdDph,  IdStr,  IdZak,  IdCin,  IdSbo,  IdAut,  MnozCelk,  VahaCelk,  BalCelk,  PaletCelk,  CenaMjKc,  CenaMjMena,  CenaCelkKc,  CenaCelkMena,  CenaPrumCelkKc,  CenaPuvKc,  CenaPuvMena,  CenaVahaKc,  CenaVahaMena,  BonProc,  ZboziUpr,        NazRad ,  Pocitat,  Misto,  ObjKodZbozi,  MnozDod,  MnozKorekce,  VahaDod,  VahaKorekce,  DenDod,  DenKon,  DenPotvrz,  DenRez,  Rez,  CenyDleVahy,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy,  Otisk,  Serie,  IdRadVazba,  CisDokVazba,  IdRadOdkud,  CisDokOdkud,  IdRadKam,  CisDokKam,  IdRoKrok,  IdIso,  MnozZbyva,  VahaZbyva)
 select   i.IdDnRad,i.CisDok,i.RadDok,i.PorTisk,i.IdZbozi,i.IdDph,i.IdStr,i.IdZak,i.IdCin,i.IdSbo,i.IdAut,i.MnozCelk,i.VahaCelk,i.BalCelk,i.PaletCelk,i.CenaMjKc,i.CenaMjMena,i.CenaCelkKc,i.CenaCelkMena,i.CenaPrumCelkKc,i.CenaPuvKc,i.CenaPuvMena,i.CenaVahaKc,i.CenaVahaMena,i.BonProc,i.ZboziUpr,rtrim(i.NazRad),i.Pocitat,i.Misto,i.ObjKodZbozi,i.MnozDod,i.MnozKorekce,i.VahaDod,i.VahaKorekce,i.DenDod,i.DenKon,i.DenPotvrz,i.DenRez,i.Rez,i.CenyDleVahy,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy,i.Otisk,i.Serie,i.IdRadVazba,i.CisDokVazba,i.IdRadOdkud,i.CisDokOdkud,i.IdRadKam,i.CisDokKam,i.IdRoKrok,i.IdIso
   ,MnozZbyva=case when i.MnozCelk-i.MnozDod+i.MnozKorekce>0 then i.MnozCelk-i.MnozDod+i.MnozKorekce else 0 end
   ,VahaZbyva=case when i.VahaCelk-i.VahaDod+i.VahaKorekce>0 then i.VahaCelk-i.VahaDod+i.VahaKorekce else 0 end
  from inserted i
-----------------------------------------------------------------------------------------------
-- doplnn sla dku nebo poad tisku
if @Akce='I'
begin
 if exists(select RadDok from @ins where RadDok*PorTisk=0)
 begin
  update i set
    @RadDok=case
     when RadDok>0 then RadDok
     when PorTisk>0 and PorTisk<32000 then convert(smallint,PorTisk)
     else (select isNull(max(r.RadDok),0) + 1 from dbo.DnRad r where r.CisDok=i.CisDok)
         +(select count(*) from @ins pred where pred.IdId<i.IdId)
     end,
    @PorTisk=case when PorTisk<>0 then PorTisk else @RadDok end,
    RadDok=@RadDok,
    PorTisk=@PorTisk
   from @ins i
  where RadDok*PorTisk=0
 end
end
-----------------------------------------------------------------------------------------------
-- doplnn IdDph
if exists(select RadDok from @ins where not IdDph>'0')
begin
 update i set IdDph=c.IdDph
 from @ins i join dbo.CeZbozi c on c.IdZbozi=i.IdZbozi
 where not i.IdDph>'0'
end
-- vlastn insert
if @Akce='I'
begin
 insert dbo.DnRad(CisDok,  RadDok,  PorTisk,  IdZbozi,  IdDph,  IdStr,  IdZak,  IdCin,  IdSbo,  IdAut,  MnozCelk,  VahaCelk,  BalCelk,  PaletCelk,  CenaMjKc,  CenaMjMena,  CenaCelkKc,  CenaCelkMena,  CenaPrumCelkKc,  CenaPuvKc,  CenaPuvMena,  CenaVahaKc,  CenaVahaMena,  BonProc,  ZboziUpr,  NazRad,  Pocitat,  Misto,  ObjKodZbozi,  MnozDod,  MnozKorekce,  MnozZbyva,  VahaDod,  VahaKorekce,  VahaZbyva,  DenDod,  DenKon,  DenPotvrz,  DenRez,  Rez,  CenyDleVahy,  Blok,  Stav,  ZarKdo,  ZarKdy,  OprKdo,  OprKdy,  Serie,  IdRadVazba,  CisDokVazba,  IdRadOdkud,  CisDokOdkud,  IdRadKam,  CisDokKam,  IdRoKrok,  IdIso)
  select        i.CisDok,i.RadDok,i.PorTisk,i.IdZbozi,i.IdDph,i.IdStr,i.IdZak,i.IdCin,i.IdSbo,i.IdAut,i.MnozCelk,i.VahaCelk,i.BalCelk,i.PaletCelk,i.CenaMjKc,i.CenaMjMena,i.CenaCelkKc,i.CenaCelkMena,i.CenaPrumCelkKc,i.CenaPuvKc,i.CenaPuvMena,i.CenaVahaKc,i.CenaVahaMena,i.BonProc,i.ZboziUpr,i.NazRad,i.Pocitat,i.Misto,i.ObjKodZbozi,i.MnozDod,i.MnozKorekce,i.MnozZbyva,i.VahaDod,i.VahaKorekce,i.VahaZbyva,i.DenDod,i.DenKon,i.DenPotvrz,i.DenRez,i.Rez,i.CenyDleVahy,i.Blok,i.Stav,i.ZarKdo,i.ZarKdy,i.OprKdo,i.OprKdy,i.Serie,i.IdRadVazba,i.CisDokVazba,i.IdRadOdkud,i.CisDokOdkud,i.IdRadKam,i.CisDokKam,i.IdRoKrok,i.IdIso
   from @ins i
 return
end
-----------------------------------------------------------------------------------------------
-- vlastn update
update r set
  PorTisk        =i.PorTisk,
  IdZbozi        =i.IdZbozi,
  IdDph          =i.IdDph,
  IdStr          =i.IdStr,
  IdZak          =i.IdZak,
  IdCin          =i.IdCin,
  IdSbo          =i.IdSbo,
  IdAut          =i.IdAut,
  MnozCelk       =i.MnozCelk,
  VahaCelk       =i.VahaCelk,
  BalCelk        =i.BalCelk,
  PaletCelk      =i.PaletCelk,
  CenaPuvKc      =i.CenaPuvKc,
  CenaPuvMena    =i.CenaPuvMena,
  CenaMjKc       =i.CenaMjKc,
  CenaMjMena     =i.CenaMjMena,
  CenaVahaKc     =i.CenaVahaKc,
  CenaVahaMena   =i.CenaVahaMena,
  CenaCelkKc     =i.CenaCelkKc,
  CenaCelkMena   =i.CenaCelkMena,
  CenaPrumCelkKc =i.CenaPrumCelkKc,
  BonProc        =i.BonProc,
  ZboziUpr       =i.ZboziUpr,
  NazRad         =i.NazRad,
  Pocitat        =i.Pocitat,
  Misto          =i.Misto,
  CenyDleVahy    =i.CenyDleVahy,
  Blok           =i.Blok,
  Stav           =i.Stav,
  OprKdo         =i.OprKdo,
  OprKdy         =i.OprKdy,
  ObjKodZbozi    =i.ObjKodZbozi,
  MnozDod        =i.MnozDod,
  MnozKorekce    =i.MnozKorekce,
  MnozZbyva      =i.MnozZbyva,
  VahaDod        =i.VahaDod,
  VahaKorekce    =i.VahaKorekce,
  VahaZbyva      =i.VahaZbyva,
  DenDod         =i.DenDod,
  DenKon         =i.DenKon,
  DenPotvrz      =i.DenPotvrz,
  DenRez         =i.DenRez,
  Rez            =i.Rez,
  Serie          =i.Serie,
  IdRadVazba     =case when i.IdRadVazba=0  then null else i.IdRadVazba  end,
  CisDokVazba    =case when i.CisDokVazba=0 then null else i.CisDokVazba end,
  IdRadOdkud     =case when i.IdRadOdkud=0  then null else i.IdRadOdkud  end,
  CisDokOdkud    =case when i.CisDokOdkud=0 then null else i.CisDokOdkud end,
  IdRadKam       =case when i.IdRadKam=0    then null else i.IdRadKam    end,
  CisDokKam      =case when i.CisDokKam=0   then null else i.CisDokKam   end,
  IdRoKrok       =i.IdRoKrok,
  IdIso          =i.IdIso
 from @ins i
  join dbo.DnRad r on r.IdDnRad=i.IdDnRad
END
GO