--NazUpg: Kontakty se zkaznky
--PopisUpg: Napojen na nov id. adrese
--KontrolaUpg: 
--ChybaUpg: 
--VypniOstatni: 0
--VypniPoUpg: 1
--ChybaHlasit: 1
GO
CREATE TRIGGER dbo.tiAdKontaktInsUpd ON dbo.AdKontakt
INSTEAD OF INSERT,UPDATE
AS
BEGIN
set nocount on
set datefirst 1
---------------- uren akce, ppadn ukonen, kdy se nic nedje --------------
declare @Akce char(1)
if (select count(*) from inserted)>0   select @Akce='I'
if (select count(*) from  deleted)>0   select @Akce=case when @Akce='I' then 'U' else 'D' end
if @Akce is null
 return
-----------------------------------------------------------------------------
-- pomocn tabulka s daty
declare @ins table (
  IdAdKontakt    int,
  IdAdAdr        int,
  IdAdr          varchar(50) COLLATE SQL_Czech_CP1250_CI_AS,
  PorKontakt     smallint,
  IdZpTel        char(10) COLLATE SQL_Czech_CP1250_CI_AS,
  JmenoKontakt   varchar(250) COLLATE SQL_Czech_CP1250_CI_AS,
  DenKontakt     smalldatetime,
  DenPlanKontakt smalldatetime,
  KdoVola        char(1) COLLATE SQL_Czech_CP1250_CI_AS,
  KdeKontakt     varchar(250) COLLATE SQL_Czech_CP1250_CI_AS,
  UkolMoje       varchar(250) COLLATE SQL_Czech_CP1250_CI_AS,
  UkolJeho       varchar(250) COLLATE SQL_Czech_CP1250_CI_AS,
  SplnilMoje     char(1) COLLATE SQL_Czech_CP1250_CI_AS,
  SplnilJeho     char(1) COLLATE SQL_Czech_CP1250_CI_AS,
  Priorita       char(1) COLLATE SQL_Czech_CP1250_CI_AS,
  SoubText       varchar(250) COLLATE SQL_Czech_CP1250_CI_AS,
  Blok           char(1) COLLATE SQL_Czech_CP1250_CI_AS,
  Stav           char(1) COLLATE SQL_Czech_CP1250_CI_AS,
  ZarKdo         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS,
  ZarKdy         datetime,
  OprKdo         varchar(50) COLLATE SQL_Czech_CP1250_CI_AS,
  OprKdy         datetime,
  Otisk          varbinary(8),
  idid           int identity(1,1) NOT NULL primary key
)
insert @ins (IdAdKontakt, IdAdAdr, IdAdr, PorKontakt, IdZpTel, JmenoKontakt, DenKontakt, DenPlanKontakt, KdoVola, KdeKontakt, UkolMoje, UkolJeho, SplnilMoje, SplnilJeho, Priorita,SoubText, Blok, Stav, ZarKdo, ZarKdy, OprKdo, OprKdy, Otisk)
 select      IdAdKontakt, IdAdAdr, IdAdr, PorKontakt, IdZpTel, JmenoKontakt, DenKontakt, DenPlanKontakt, KdoVola, KdeKontakt, UkolMoje, UkolJeho, SplnilMoje, SplnilJeho, Priorita,SoubText, Blok, Stav, ZarKdo, ZarKdy, OprKdo, OprKdy, Otisk
   from inserted
-----------------------------------------------------------------------------
----- IdAdr x IdAdAdr
-- pi vloen novho najdu id podle kle, pokud id nezadal
if @Akce='I'
 if exists(select * from @ins i where i.IdAdAdr=0 and i.IdAdr>'0')
  update i set IdAdAdr=a.IdAdAdr
   from @ins i
    join AdAdr a (nolock) on a.IdAdr=i.IdAdr
   where i.IdAdAdr=0 and i.IdAdr>'0'
-- pokud zmnm kl, najdu k nmu id
if @Akce='U'
 if exists(select * from @ins i join deleted d on d.IdAdKontakt=i.IdAdKontakt where not d.IdAdr=i.IdAdr)
  update i set IdAdAdr=a.IdAdAdr
   from @ins i
    join deleted d on d.IdAdKontakt=i.IdAdKontakt
    join AdAdr a (nolock) on a.IdAdr=i.IdAdr
   where not d.IdAdr=i.IdAdr and not i.IdAdAdr=a.IdAdAdr
-- te sladm kl podle id, protoe id u je dobe
update i set IdAdr=a.IdAdr
 from @ins i
  join AdAdr a (nolock) on a.IdAdAdr=i.IdAdAdr
 where not i.IdAdr=a.IdAdr
-----------------------------------------------------------------------------
-- vlastn insert
if @Akce='I'
begin
insert dbo.AdKontakt (IdAdAdr, IdAdr, PorKontakt, IdZpTel, JmenoKontakt, DenKontakt, DenPlanKontakt, KdoVola, KdeKontakt, UkolMoje, UkolJeho, SplnilMoje, SplnilJeho, Priorita,SoubText, ZarKdo, ZarKdy, OprKdo, OprKdy, Blok, Stav)
 select               IdAdAdr, IdAdr, PorKontakt, IdZpTel, JmenoKontakt, DenKontakt, DenPlanKontakt, KdoVola, KdeKontakt, UkolMoje, UkolJeho, SplnilMoje, SplnilJeho, Priorita,SoubText, ZarKdo, ZarKdy, OprKdo, OprKdy, Blok, Stav
   from @ins
end
-----------------------------------------------------------------------------
-- vlastn update
if @Akce='U'
begin
 update c set
  IdAdAdr       =i.IdAdAdr,
  IdAdr         =i.IdAdr,
  PorKontakt    =i.PorKontakt,
  IdZpTel       =i.IdZpTel,
  JmenoKontakt  =i.JmenoKontakt,
  DenKontakt    =i.DenKontakt,
  DenPlanKontakt=i.DenPlanKontakt,
  KdoVola       =i.KdoVola,
  KdeKontakt    =i.KdeKontakt,
  UkolMoje      =i.UkolMoje,
  UkolJeho      =i.UkolJeho,
  SplnilMoje    =i.SplnilMoje,
  SplnilJeho    =i.SplnilJeho,
  Priorita      =i.Priorita,
  SoubText      =i.SoubText,
  Blok      =i.Blok,
  Stav      =i.Stav
 from dbo.AdKontakt c join @ins i on i.IdAdKontakt=c.IdAdKontakt
end
END
GO