--NazUpg: Pihlky ZP
--PopisUpg: Pihlen jen jedn osoby
--KontrolaUpg:
--ChybaUpg:
--VypniOstatni: 0
--VypniPoUpg: 0
--ChybaHlasit: 1
GO
ALTER PROC dbo.spMzZdrPojHlas (@Mes char(7), @PrihlOdhl char(1), @DleKc char(1)) as
BEGIN
set nocount on
/*
declare @Mes char(7)       select @Mes='2012/01'
declare @PrihlOdhl char(1) select @PrihlOdhl=''
declare @DleKc char(1)     select @DleKc='1'
*/
-- seznam zamstnanc by ml pijt z programu
if object_id('tempdb..#MzZdrPojHlas') is null
 select distinct c.IdClovek into #MzZdrPojHlas from MzClovek c where c.IdClovek>'0'
--
declare @DenOd datetime    select @DenOd=convert(datetime,@Mes+'/01',111)
declare @DenDo datetime    select @DenDo=dateadd(day,-1,dateadd(month,1,@DenOd))
declare @MesPred char(7)   select @MesPred=dbo.fnMesPred(@Mes)
declare @DenPred datetime  select @DenPred=dateadd(day,-1,@DenOd)
declare @MesDalsi char(7)  select @MesDalsi=dbo.fnMesDalsi(@Mes)
declare @DenHlas datetime  select @DenHlas=convert(datetime,convert(varchar(10),getdate(),111),111)
-- nkte chtj odhlaovat, a kdy je v kolonce Ukoncit znak 'x'
declare @OdhlaskaUkoncitZnak varchar(100)
select @OdhlaskaUkoncitZnak=dbo.fnMzNastav('OdhlaskaUkoncitZnak',NULL,NULL,'')
-- pomry
declare @PomerH char(1) select @PomerH='h'
declare @PomerC char(1) select @PomerC='c'
declare @PomerP char(1) select @PomerP='p'
-- seznam zajmavch zamstnanc
declare @Zam table (
  IdId     int identity(1,1) not null primary key
 ,IdClovek char(10) COLLATE SQL_Czech_CP1250_CI_AS
 ,IdZam    char(10) COLLATE SQL_Czech_CP1250_CI_AS
 ,Mes      char(7)  COLLATE SQL_Czech_CP1250_CI_AS
 ,IdPomer  char(1)  COLLATE SQL_Czech_CP1250_CI_AS
 ,Akce     char(1)  COLLATE SQL_Czech_CP1250_CI_AS
 ,PomerOd  datetime
 ,PomerDo  datetime
 ,DleKc    bit
)
--------------------------------------------------------------------------
-- pihlky podle dne zatku pomru
insert @Zam(IdClovek,  IdZam, Mes,  IdPomer,Akce,PomerOd,PomerDo,DleKc)
 select   z.IdClovek,z.IdZam,@Mes,z.IdPomer,'p' ,z.DenOd,z.DenDo,0
  from MzZam z (nolock)
   join #MzZdrPojHlas s on s.IdClovek=z.IdClovek
  where z.DenOd between @DenOd and @DenDo and z.IdPomer=@PomerH
-- odhlky podle dne konce pomru
insert @Zam(IdClovek,  IdZam, Mes,  IdPomer,Akce,PomerOd,PomerDo,DleKc)
 select   z.IdClovek,z.IdZam,@Mes,z.IdPomer,'o' ,z.DenOd,z.DenDo,0
  from MzZam z (nolock)
   join #MzZdrPojHlas s on s.IdClovek=z.IdClovek
  where z.DenDo between @DenOd and @DenDo and z.IdPomer=@PomerH
   and case when @OdhlaskaUkoncitZnak>'' then charindex(@OdhlaskaUkoncitZnak,z.Ukoncit) else 1 end>0
--------------------------------------------------------------------------
-- dohody podle toho, zda maj i nemaj zdravotn pojitn
declare @Odv table (IdId int identity(1,1) not null primary key, IdZam char(10) COLLATE SQL_Czech_CP1250_CI_AS, IdClovek char(10) COLLATE SQL_Czech_CP1250_CI_AS, OdvPredKc money, OdvKc money, OdvDalsiKc money)
insert @Odv (IdZam,IdClovek,OdvPredKc,OdvKc,OdvDalsiKc)
 select o.IdZam,z.IdClovek
   ,OdvPredKc =sum(case when o.Mes=@MesPred  then o.OdvFirKc+o.OdvZamKc else 0 end)
   ,OdvKc     =sum(case when o.Mes=@Mes      then o.OdvFirKc+o.OdvZamKc else 0 end)
   ,OdvDalsiKc=sum(case when o.Mes=@MesDalsi then o.OdvFirKc+o.OdvZamKc else 0 end)
   from MzOdvMes o (nolock)
    join MzZam z (nolock) on o.IdZam=z.IdZam
     and not z.IdPomer=@PomerH
    join #MzZdrPojHlas s on s.IdClovek=z.IdClovek
   where o.IdOdvTyp='zdr' and o.Mes in (@Mes,@MesPred,@MesDalsi)
   group by o.IdZam,z.IdClovek
-- pihlky
insert @Zam(IdClovek,  IdZam, Mes,  IdPomer,Akce,PomerOd,PomerDo,DleKc)
 select   z.IdClovek,z.IdZam,@Mes,z.IdPomer,'p' ,case when z.DenOd>d.DenOd then z.DenDo else d.DenOd end,z.DenDo,1
  from @Odv o
   join MzZam z (nolock) on z.IdZam=o.IdZam
   join #MzZdrPojHlas s on s.IdClovek=z.IdClovek
   join (select q.IdZam,DenOd=convert(datetime,min(om.Mes)+'/01',111) from @Odv q join MzOdvMes om (nolock) on om.IdZam=q.IdZam and om.IdOdvTyp='zdr' and om.OdvZamKc>0 group by q.IdZam) d on d.IdZam=o.IdZam
  where isnull(o.OdvPredKc,0)=0 and o.OdvKc>0
-- odhlky
insert @Zam(IdClovek,  IdZam, Mes    ,  IdPomer,Akce,PomerOd,PomerDo,DleKc)
 select   z.IdClovek,z.IdZam,@MesPred,z.IdPomer,'o' ,z.DenOd,case when z.DenDo>@DenPred then @DenPred else z.DenDo end,1
  from @Odv o
   join MzZam z (nolock) on z.IdZam=o.IdZam
   join #MzZdrPojHlas s on s.IdClovek=z.IdClovek
  where isnull(o.OdvKc,0)=0 and o.OdvPredKc>0
--select o.*,z.IdPomer from @Odv o join MzZam z on z.IdZam=o.IdZam
--select * from @Zam
----------------------------------------------------------------------------
---------- neodhlauji nkoho, kdo m dl hlavn pomr?
-- odhlka v tomto msci a m hlavn pomr
--select q.IdClovek,'odhlka v tomto msci a m hlavn pomr'
delete q
 from @Zam q
  join MzZam z (nolock) on z.IdClovek=q.IdClovek and z.IdPomer=@PomerH and z.DenDo>@DenDo
 where q.Akce='o' and q.Mes=@Mes
-- odhlka v pedchozm msci a m hlavn pomr
--select q.IdClovek,'odhlka v pedchozm msci a m hlavn pomr'
delete q
 from @Zam q
  join MzZam z (nolock) on z.IdClovek=q.IdClovek and z.IdPomer=@PomerH and z.DenDo>@DenPred
 where q.Akce='o' and q.Mes=@MesPred
---------- neodhlauji nkoho, kdo m nsledn pojitn v jinm pomru?
--select q.IdClovek,'neodhlauji nkoho, kdo m nsledn pojitn v jinm pomru?'
delete q
 from @Zam q
  join @Odv o on o.IdClovek=q.IdClovek and o.OdvKc>0
 where q.Akce='o' and q.Mes=@MesPred
----------------------------------------------------------------------------
---------- nepihlauji nkoho, kdo u m hlavn pomr?
--select q.IdClovek,'nepihlauji nkoho, kdo u m hlavn pomr?'
delete q
 from @Zam q
   join MzZam z (nolock) on z.IdClovek=q.IdClovek and z.IdPomer=@PomerH and z.DenOd<@DenOd and z.DenDo>=@DenPred
  where q.Akce='p' and q.Mes=@Mes
---------- nepihlauji nkoho, kdo ml dve pojitn v jinm pomru?
--select q.IdClovek,'nepihlauji nkoho, kdo ml dve pojitn v jinm pomru?'
delete q
 from @Zam q
  join @Odv o on o.IdClovek=q.IdClovek and o.OdvPredKc>0
 where q.Akce='p' and q.Mes=@Mes
--select * from @Zam
----------------------------------------------------------------------------
-- seznam zajmavch osob
declare @Clovek table (
  IdId     int identity(1,1) not null primary key
 ,IdClovek char(10) COLLATE SQL_Czech_CP1250_CI_AS
 ,Mes      char(7)  COLLATE SQL_Czech_CP1250_CI_AS
 ,Akce     char(1)  COLLATE SQL_Czech_CP1250_CI_AS
 ,IdZdrPojHlasTyp  char(1)  COLLATE SQL_Czech_CP1250_CI_AS
 ,IdZdrPojHlasStat char(1)  COLLATE SQL_Czech_CP1250_CI_AS
 ,PomerOd  datetime
 ,PomerDo  datetime
 ,DleKc    bit
)
insert @Clovek (IdClovek,Mes,Akce,IdZdrPojHlasTyp,IdZdrPojHlasStat,    PomerOd,     PomerDo , DleKc)
 select         IdClovek,Mes,Akce,Akce           ,''              ,min(PomerOd),max(PomerDo),min(case when DleKc=1 then 1 else 0 end)
  from @Zam
  group by IdClovek,Mes,Akce
---------------------------- zmna pojiovny ---------------------------------------------
-- odhlsm od pvodn pojiovny
insert @Clovek (IdClovek, Mes    ,Akce,IdZdrPojHlasTyp,PomerOd ,PomerDo ,IdZdrPojHlasStat,DleKc)
 select       p.IdClovek,@MesPred,'o' ,'o'            ,@DenPred,@DenPred,''              ,0
 from MzZdrPojClovek p (nolock)
       join MzZdrPojClovek x (nolock)   on   x.IdClovek=p.IdClovek and not x.IdZdrPoj=p.IdZdrPoj and x.MesDo=@MesPred
  left join MzZdrPojHlas   h (nolock)   on   h.IdClovek=p.IdClovek and h.IdZdrPojHlasTyp='o' and h.Mes=@MesPred
  left join @Clovek        q            on   q.IdClovek=p.IdClovek and q.Akce           ='o' and h.Mes=@MesPred
 where p.MesOd=@Mes
   and h.IdClovek is null
   and q.IdClovek is null
-- pihlsm k nov pojiovn
insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
 select       p.IdClovek,@Mes,'p' ,'p'            ,@DenOd ,@DenOd ,''              ,0
 from MzZdrPojClovek p (nolock)
       join MzZdrPojClovek x (nolock)   on   x.IdClovek=p.IdClovek and not x.IdZdrPoj=p.IdZdrPoj and x.MesDo=@MesPred
  left join MzZdrPojHlas   h (nolock)   on   h.IdClovek=p.IdClovek and h.IdZdrPojHlasTyp='p' and h.Mes=@Mes
  left join @Clovek        q            on   q.IdClovek=p.IdClovek and q.Akce           ='p' and h.Mes=@Mes
 where p.MesOd=@Mes
   and h.IdClovek is null
   and q.IdClovek is null
--------------------------------------------------------------------------------------------
------------------------ dchodci a studenti soubn s pihlenm ------------------------
update c set IdZdrPojHlasStat='d'
 from @Clovek c
  join MzDuchClovek d (nolock) on d.IdClovek=c.IdClovek and @DenDo between d.DenOd and d.DenDo
                                  and (d.IdDuch in ('starobn','vdovsk','vdoveck') or (d.IdDuch like 'invalidn%' and not d.IdDuch='invalidn ZPS' and not d.IdDuch='invalidn 1. stupn'))
 where c.Akce='p'
update c set IdZdrPojHlasStat='g'
 from @Clovek c
  join MzDuchClovek d (nolock) on d.IdClovek=c.IdClovek and @DenDo between d.DenOd and d.DenDo
                                  and d.IdDuch='student'
 where c.Akce='p'
-------------------------------------- dchodci a studenti ---------------------------------------
---------- dchodci a studenti zatek
if exists (select * from MzDuchClovek d (nolock) where (d.IdDuch in ('starobn','vdovsk','vdoveck','student') or (d.IdDuch like 'invalidn%' and not d.IdDuch='invalidn ZPS')) and d.DenOd between @DenOd and @DenDo)
begin
 insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
  select       d.IdClovek,@Mes,'p' ,''             ,d.DenOd,d.DenOd,case when d.IdDuch='student' then 'g' else 'd' end,0
   from MzDuchClovek d (nolock)
    left join MzZdrPojHlas h (nolock) on h.IdClovek=d.IdClovek and h.DenPomer=d.DenOd and h.IdZdrPojHlasStat=case when d.IdDuch='student' then 'g' else 'd' end
   where d.DenOd between @DenOd and @DenDo
    and (d.IdDuch in ('starobn','vdovsk','vdoveck','student') or (d.IdDuch like 'invalidn%' and not d.IdDuch='invalidn ZPS'))
    and h.IdClovek is null
end
---------- dchodci a studenti konec
if exists (select * from MzDuchClovek d (nolock) where (d.IdDuch in ('starobn','vdovsk','vdoveck','student') or (d.IdDuch like 'invalidn%' and not d.IdDuch='invalidn ZPS')) and DenDo between @DenOd and @DenDo)
begin
 insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
  select       d.IdClovek,@Mes,'o' ,''             ,d.DenDo,d.DenDo,case when d.IdDuch='student' then 'f' else 'p' end,0
   from MzDuchClovek d (nolock)
    left join MzZdrPojHlas h (nolock) on h.IdClovek=d.IdClovek and h.DenPomer=d.DenOd and h.IdZdrPojHlasStat=case when d.IdDuch='student' then 'f' else 'p' end
   where d.DenDo between @DenOd and @DenDo
    and (d.IdDuch in ('starobn','vdovsk','vdoveck','student') or (d.IdDuch like 'invalidn%' and not d.IdDuch='invalidn ZPS'))
    and h.IdClovek is null
end
-------------------------------------- matesk a rodiovsk ---------------------------------------
---------- matesk a rodiovsk zatek
if exists (select * from MzAbsZam a (nolock) join MzPol p (nolock) on p.IdPol=a.IdPol and p.IdPolParam in ('nemoc/matesk','vynt/rodiovsk') where a.DenOd between @DenOd and @DenDo)
 insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
  select       z.IdClovek,@Mes,'p' ,''             ,a.DenDo,a.DenOd,'m'             ,0
   from MzAbsZam a (nolock)
    join MzPol   p (nolock)  on p.IdPol=a.IdPol and p.IdPolParam in ('nemoc/matesk','vynt/rodiovsk')
    join MzZam   z (nolock)  on z.IdZam=a.IdZam
    left join MzZdrPojHlas h (nolock) on h.IdClovek=z.IdClovek and h.DenPomer=a.DenOd and h.IdZdrPojHlasStat='m'
   where a.DenOd between @DenOd and @DenDo
    and h.IdClovek is null
---------- matesk a rodiovsk konec
if exists (select * from MzAbsZam a (nolock) join MzPol p (nolock) on p.IdPol=a.IdPol and p.IdPolParam in ('nemoc/matesk','vynt/rodiovsk') where a.DenDo between @DenDo and @DenDo and a.PujdeDal=0)
 insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
  select       z.IdClovek,@Mes,'o' ,''             ,a.DenDo,a.DenDo,'u'             ,0
   from MzAbsZam a (nolock)
    join MzPol   p (nolock)  on p.IdPol=a.IdPol and p.IdPolParam in ('nemoc/matesk','vynt/rodiovsk')
    join MzZam   z (nolock)  on z.IdZam=a.IdZam
    left join MzZdrPojHlas h (nolock) on h.IdClovek=z.IdClovek and h.DenPomer=a.DenOd and h.IdZdrPojHlasStat='u'
   where a.DenDo between @DenOd and @DenDo and a.PujdeDal=0
    and h.IdClovek is null
-------------------------------------- nemoc po pomru ---------------------------------------
---------- nemoc po pomru zatek
if exists (select * from MzAbsZam a (nolock) join MzPol p (nolock) on p.IdPol=a.IdPol and p.IdPolParam like 'nemoc%' join MzZam z (nolock) on z.IdZam=a.IdZam and a.DenDo>z.DenDo where a.DenOd between @DenOd and @DenDo)
 insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
  select       z.IdClovek
    ,Mes=left(convert(varchar(10),case when a.DenOd>z.DenDo then a.DenOd else dateadd(day,1,z.DenDo) end,111),7)
    ,Akce='p'
    ,IdZdrPojHlasTyp=''
    ,DenOd=                       case when a.DenOd>z.DenDo then a.DenOd else dateadd(day,1,z.DenDo) end
    ,DenDo=                       case when a.DenOd>z.DenDo then a.DenOd else dateadd(day,1,z.DenDo) end
    ,IdZdrPojHlasStat='n'
    ,DleKc=0
   from MzAbsZam a (nolock)
    join MzPol   p (nolock)  on p.IdPol=a.IdPol and p.IdPolParam like 'nemoc%'
    join MzZam   z (nolock)  on z.IdZam=a.IdZam and a.DenDo>z.DenDo
    left join MzZdrPojHlas h (nolock) on h.IdClovek=z.IdClovek and h.DenPomer=case when a.DenOd>z.DenDo then a.DenOd else dateadd(day,1,z.DenDo) end and h.IdZdrPojHlasStat='n'
   where a.DenOd between @DenOd and @DenDo
    and h.IdClovek is null
---------- nemoc po pomru konec
if exists (select * from MzAbsZam a (nolock) join MzPol p (nolock) on p.IdPol=a.IdPol and p.IdPolParam like 'nemoc%' join MzZam z (nolock) on z.IdZam=a.IdZam and a.DenDo>z.DenDo where a.DenDo between @DenOd and @DenDo and a.PujdeDal=0)
 insert @Clovek (IdClovek, Mes,Akce,IdZdrPojHlasTyp,PomerOd,PomerDo,IdZdrPojHlasStat,DleKc)
  select       z.IdClovek,@Mes,'o' ,''             ,a.DenDo,a.DenDo,'k'             ,0
   from MzAbsZam a (nolock)
    join MzPol   p (nolock)  on p.IdPol=a.IdPol and p.IdPolParam like 'nemoc%'
    join MzZam   z (nolock)  on z.IdZam=a.IdZam and a.DenDo>z.DenDo
    left join MzZdrPojHlas h (nolock) on h.IdClovek=z.IdClovek and h.DenPomer=a.DenDo and h.IdZdrPojHlasStat='k'
   where a.DenDo between @DenOd and @DenDo and a.PujdeDal=0
    and h.IdClovek is null
---------------------------------------------------------------------------------------------------------
-- zpis do dat
insert MzZdrPojHlas (IdClovek,    IdZdrPoj,        IdZdrPojHlasTyp ,  IdZdrPojHlasStat       ,  Mes, DenHlas, DenPomer, RodneCislo)
 select            c.IdClovek,zpc.IdZdrPoj,upper(q.IdZdrPojHlasTyp),upper(q.IdZdrPojHlasStat),q.Mes,@DenHlas
  ,DenPomer=case when q.Akce='p' then q.PomerOd else q.PomerDo end
  ,RodneCislo=case
              when c.ZdrCislo>'0' then c.ZdrCislo
              when c.RodneCislo>'0' then c.RodneCislo
              when zpc.PojCisSml>'0' then left(zpc.PojCisSml,10)
              else upper(replace(c.Sex,'','Z'))+replace(convert(varchar(10),c.DenNar,104),'.','')
              end
  from @Clovek q
   join MzClovek         c (nolock)   on   c.IdClovek=q.IdClovek
   join MzZdrPojClovek   zpc (nolock) on zpc.IdClovek=q.IdClovek and q.Mes between zpc.MesOd and zpc.MesDo
   join MzZdrPoj         zp (nolock)  on  zp.IdZdrPoj=zpc.IdZdrPoj
   left join MzBytClovek bc (nolock)  on  bc.IdClovek=q.IdClovek and q.PomerOd between bc.DenOd and bc.DenDo and bc.IdByt='trval'
   left join MzZdrPojHlas h (nolock)  on   h.IdClovek=q.IdClovek and h.Mes=q.Mes and h.IdZdrPojHlasTyp=q.IdZdrPojHlasTyp and h.IdZdrPojHlasStat=q.IdZdrPojHlasStat
  where h.IdClovek is null
   and q.Akce =case when @PrihlOdhl>'0' then @PrihlOdhl else q.Akce end
   and q.DleKc=case when @DleKc    >'0' then q.DleKc else 0 end
END
GO