--NazUpg: Dochzka vazku
--PopisUpg: Generovn dochzky podle plnu turnus
--KontrolaUpg: 
--ChybaUpg: 
--VypniOstatni: 0
--VypniPoUpg: 1
--ChybaHlasit: 1
GO
ALTER PROC dbo.spMzDochUvazGen(@Mes char(7),@IdUvaz varchar(5)='0') as
BEGIN
/*
declare @Mes    char(7)    select @Mes='2018/08'
declare @IdUvaz varchar(5) select @IdUvaz='0'
select IdUvaz,count(*) from MzDochUvaz where Mes=@Mes group by IdUvaz
delete MzDochUvaz where Mes=@Mes and IdUvaz like '%'
select IdUvaz,count(*) from MzDochUvaz where Mes=@Mes group by IdUvaz
*/
set nocount on
--
if (select count(*) from MzMes (nolock) where Mes=@Mes and PovolMz>'0')=0
begin
 raiserror ('Zadan obdob pro generovn dochzky vazku je uzaven nebo vbec neexistuje.',11,2)
 rollback transaction
 return
end
--
set datefirst 1
declare @DenPoc datetime select @DenPoc=dbo.fnDatePrvni(@Mes)
declare @DenKon datetime select @DenKon=dbo.fnDatePosl (@Mes)
declare @Den    datetime select @Den=@DenPoc
-- bez podmnky
declare @u table (
  IdUvaz char(5) collate SQL_Czech_CP1250_CI_AS NOT NULL primary key
)
if @IdUvaz='0' or @IdUvaz='' or @IdUvaz='*'
	select @IdUvaz='%'
---------------------------------------------------------
-- seznam vazk
insert @u(IdUvaz)
 select u.IdUvaz
  from MzUvazMes u (nolock)
   left join MzDochUvaz du (nolock) on du.IdUvaz=u.IdUvaz and du.Mes=u.Mes
  where u.IdUvaz>'0' and u.IdUvaz like @IdUvaz and u.Mes=@Mes and not u.Stav='n'
   and du.IdUvaz is null
---------------------------------------------------------
-- generovn podle plnu turnus
insert MzDochUvaz(IdUvaz,  Mes,  IdPol,    PolHod,CasOd)
 select         x.IdUvaz, @Mes,x.IdPol,x.PraceHod,convert(datetime,convert(char(10),x.Den,121)+' '+x.HhmmOd,121)
  from
   (
    select x.*,d.Dd,p.IdPichSmena,p.PorDen,d.Den,s.HhmmOd,s.PraceHod,um.IdPol
     from
      (
       select
          q.IdUvaz
         ,r.IdDochPlanTyp
         ,p.PlanDny
         ,DnyPosun =datediff(day,r.DenPlanOd,convert(datetime,@Mes+'/01',111))
         ,FazePosun=datediff(day,r.DenPlanOd,convert(datetime,@Mes+'/01',111))%p.PlanDny
         ,DenPlanOd=convert(varchar(10),r.DenPlanOd,104)
        from @u q
         join MzUvazRok r on r.IdUvaz=q.IdUvaz and r.Rokal=convert(smallint,left(@Mes,4))
         join MzDochPlanTyp p on p.IdDochPlanTyp=r.IdDochPlanTyp
        where r.IdDochPlanTyp>0 and r.DenPlanOd is not null and p.PlanDny>0
      ) x
      join MzUvazMes um on um.IdUvaz=x.IdUvaz and um.Mes=@Mes
      left join MzDochPlan p on p.IdDochPlanTyp=x.IdDochPlanTyp
      left join ExDen d on d.Mes=@Mes
      left join MzPichSmena s on s.IdPichSmena=p.IdPichSmena
     where (d.Dd+x.FazePosun)%x.PlanDny=case when p.PorDen<x.PlanDny then p.PorDen else 0 end
   ) x
   order by IdUvaz,x.Den
-- vazky co si tge nco vygenerovaly ze seznamu vyhodm, zbudou standardn vazky
delete u
 from @u u
  join MzDochUvaz du (nolock) on du.IdUvaz=u.IdUvaz and du.Mes=@Mes
---------------------------------------------------------
-- rovnomrn vazky plnm jen v pracovnch dnech, nerovnomrn dm vechny dny
-- svtek oznam jen u rovnomrnch vazk, nebo nerovnomrn ho nemaj ve mzd
insert MzDochUvaz (IdUvaz, Mes,  IdPol,PolHod        ,  JeSvatek, CasOd)
  select         u.IdUvaz,@Mes,u.IdPol,u.UvazSmenaHod,s.JeSvatek
    ,CasOd=convert(datetime,convert(char(10),s.Den,121)+' '+case when isnull(u.Hhmm,'00:00')>'00:00' then u.Hhmm else '06:00' end,121)
   from @u q 
         join MzUvazMes   u (nolock) on u.IdUvaz=q.IdUvaz and u.Mes=@Mes
         join MzUvazRok  ur (nolock) on ur.IdUvaz=u.IdUvaz and ur.Rokal=convert(smallint,left(u.Mes,4))
     				join MzPol       p (nolock) on u.IdPol=p.IdPol
						   join ExDen       s (nolock) on s.Mes=u.Mes
    --left join MzDochUvaz du (nolock) on du.IdUvaz=u.IdUvaz and convert(varchar(10),du.CasOd,104)=convert(varchar(10),s.Den,104)
   where not (ur.JeRovnomer=1 and datepart(weekday,s.Den)>5)
    --and du.IdDochUvaz is null
   order by u.IdUvaz,s.Den
END
GO